Index: pr_inversion/docs/sphinx/genmods.py
===================================================================
--- pr_inversion/docs/sphinx/genmods.py	(revision d84a90c534af8d3f131c880c4fa0f3dce1b3f116)
+++ pr_inversion/docs/sphinx/genmods.py	(revision 888499639fdcac9ce5f05f9de8a422019fba20a0)
@@ -16,4 +16,6 @@
    :inherited-members:
    :show-inheritance:
+   :special-members:
+   :private-members:
 
 """
@@ -50,11 +52,15 @@
     with open(os.path.join(dir,'index.rst'),'w') as f:
         f.write(INDEX_TEMPLATE%locals())
+        
+modules = []
+path = os.path.dirname(os.path.join('..', '..', 'pr_inversion'))
+path = os.path.join(path, 'src', 'sans', 'pr')
+list = os.listdir(path)
 
-
-modules=[
-    ('distance_explorer', 'distance_explorer'),
-    ('invertor', 'invertor'),
-    ('num_term', 'num_term'),
-]
+for item in list:
+    toks = os.path.splitext(os.path.basename(item))
+    if toks[1]=='.py' and toks[0] not in ["__init__"]:
+        exec "module = ('%s', '%s')"%(toks[0], toks[0])
+        modules.append(module)
 package ='sans.pr'
 package_name ='Reference'
Index: pr_inversion/docs/sphinx/html/.buildinfo
===================================================================
--- pr_inversion/docs/sphinx/html/.buildinfo	(revision a7c772ea8096f970be31b02f50fc8daa9d572a54)
+++ pr_inversion/docs/sphinx/html/.buildinfo	(revision 888499639fdcac9ce5f05f9de8a422019fba20a0)
@@ -1,4 +1,4 @@
 # Sphinx build info version 1
 # This file hashes the configuration used when building these files. When it is not found, a full rebuild will be done.
-config: e33fcce3b78882edfe8ac6abaae08878
+config: 7c9c66029a79c99968c5679f985dea3c
 tags: fbb0d17656682115ca4d033fb2f83ba1
Index: pr_inversion/docs/sphinx/html/_static/doctools.js
===================================================================
--- pr_inversion/docs/sphinx/html/_static/doctools.js	(revision a7c772ea8096f970be31b02f50fc8daa9d572a54)
+++ pr_inversion/docs/sphinx/html/_static/doctools.js	(revision 888499639fdcac9ce5f05f9de8a422019fba20a0)
@@ -186,7 +186,7 @@
         });
       }, 10);
-      $('<li class="highlight-link"><a href="javascript:Documentation.' +
-        'hideSearchWords()">' + _('Hide Search Matches') + '</a></li>')
-          .appendTo($('.sidebar .this-page-menu'));
+      $('<p class="highlight-link"><a href="javascript:Documentation.' +
+        'hideSearchWords()">' + _('Hide Search Matches') + '</a></p>')
+          .appendTo($('#searchbox'));
     }
   },
@@ -214,5 +214,5 @@
    */
   hideSearchWords : function() {
-    $('.sidebar .this-page-menu li.highlight-link').fadeOut(300);
+    $('#searchbox .highlight-link').fadeOut(300);
     $('span.highlighted').removeClass('highlighted');
   },
Index: pr_inversion/docs/sphinx/html/_static/searchtools.js
===================================================================
--- pr_inversion/docs/sphinx/html/_static/searchtools.js	(revision a7c772ea8096f970be31b02f50fc8daa9d572a54)
+++ pr_inversion/docs/sphinx/html/_static/searchtools.js	(revision 888499639fdcac9ce5f05f9de8a422019fba20a0)
@@ -1,5 +1,5 @@
 /*
- * searchtools.js
- * ~~~~~~~~~~~~~~
+ * searchtools.js_t
+ * ~~~~~~~~~~~~~~~~
  *
  * Sphinx JavaScript utilties for the full-text search.
@@ -37,8 +37,9 @@
 }
 
+
 /**
  * Porter Stemmer
  */
-var PorterStemmer = function() {
+var Stemmer = function() {
 
   var step2list = {
@@ -301,18 +302,18 @@
 
   query : function(query) {
-    var stopwords = ['and', 'then', 'into', 'it', 'as', 'are', 'in',
-                     'if', 'for', 'no', 'there', 'their', 'was', 'is',
-                     'be', 'to', 'that', 'but', 'they', 'not', 'such',
-                     'with', 'by', 'a', 'on', 'these', 'of', 'will',
-                     'this', 'near', 'the', 'or', 'at'];
-
-    // stem the searchterms and add them to the correct list
-    var stemmer = new PorterStemmer();
+    var stopwords = ["and","then","into","it","as","are","in","if","for","no","there","their","was","is","be","to","that","but","they","not","such","with","by","a","on","these","of","will","this","near","the","or","at"];
+
+    // Stem the searchterms and add them to the correct list
+    var stemmer = new Stemmer();
     var searchterms = [];
     var excluded = [];
     var hlterms = [];
     var tmp = query.split(/\s+/);
-    var object = (tmp.length == 1) ? tmp[0].toLowerCase() : null;
+    var objectterms = [];
     for (var i = 0; i < tmp.length; i++) {
+      if (tmp[i] != "") {
+          objectterms.push(tmp[i].toLowerCase());
+      }
+
       if ($u.indexOf(stopwords, tmp[i]) != -1 || tmp[i].match(/^\d+$/) ||
           tmp[i] == "") {
@@ -345,7 +346,4 @@
     var titles = this._index.titles;
     var terms = this._index.terms;
-    var objects = this._index.objects;
-    var objtypes = this._index.objtypes;
-    var objnames = this._index.objnames;
     var fileMap = {};
     var files = null;
@@ -358,37 +356,16 @@
 
     // lookup as object
-    if (object != null) {
-      for (var prefix in objects) {
-        for (var name in objects[prefix]) {
-          var fullname = (prefix ? prefix + '.' : '') + name;
-          if (fullname.toLowerCase().indexOf(object) > -1) {
-            match = objects[prefix][name];
-            descr = objnames[match[1]] + _(', in ') + titles[match[0]];
-            // XXX the generated anchors are not generally correct
-            // XXX there may be custom prefixes
-            result = [filenames[match[0]], fullname, '#'+fullname, descr];
-            switch (match[2]) {
-            case 1: objectResults.push(result); break;
-            case 0: importantResults.push(result); break;
-            case 2: unimportantResults.push(result); break;
-            }
-          }
-        }
-      }
-    }
-
-    // sort results descending
-    objectResults.sort(function(a, b) {
-      return (a[1] > b[1]) ? -1 : ((a[1] < b[1]) ? 1 : 0);
-    });
-
-    importantResults.sort(function(a, b) {
-      return (a[1] > b[1]) ? -1 : ((a[1] < b[1]) ? 1 : 0);
-    });
-
-    unimportantResults.sort(function(a, b) {
-      return (a[1] > b[1]) ? -1 : ((a[1] < b[1]) ? 1 : 0);
-    });
-
+    for (var i = 0; i < objectterms.length; i++) {
+      var others = [].concat(objectterms.slice(0,i),
+                             objectterms.slice(i+1, objectterms.length))
+      var results = this.performObjectSearch(objectterms[i], others);
+      // Assume first word is most likely to be the object,
+      // other words more likely to be in description.
+      // Therefore put matches for earlier words first.
+      // (Results are eventually used in reverse order).
+      objectResults = results[0].concat(objectResults);
+      importantResults = results[1].concat(importantResults);
+      unimportantResults = results[2].concat(unimportantResults);
+    }
 
     // perform the search on the required terms
@@ -490,5 +467,5 @@
               displayNextItem();
             });
-          });
+          }, "text");
         } else {
           // no source available, just display title
@@ -511,4 +488,69 @@
     }
     displayNextItem();
+  },
+
+  performObjectSearch : function(object, otherterms) {
+    var filenames = this._index.filenames;
+    var objects = this._index.objects;
+    var objnames = this._index.objnames;
+    var titles = this._index.titles;
+
+    var importantResults = [];
+    var objectResults = [];
+    var unimportantResults = [];
+
+    for (var prefix in objects) {
+      for (var name in objects[prefix]) {
+        var fullname = (prefix ? prefix + '.' : '') + name;
+        if (fullname.toLowerCase().indexOf(object) > -1) {
+          var match = objects[prefix][name];
+          var objname = objnames[match[1]][2];
+          var title = titles[match[0]];
+          // If more than one term searched for, we require other words to be
+          // found in the name/title/description
+          if (otherterms.length > 0) {
+            var haystack = (prefix + ' ' + name + ' ' +
+                            objname + ' ' + title).toLowerCase();
+            var allfound = true;
+            for (var i = 0; i < otherterms.length; i++) {
+              if (haystack.indexOf(otherterms[i]) == -1) {
+                allfound = false;
+                break;
+              }
+            }
+            if (!allfound) {
+              continue;
+            }
+          }
+          var descr = objname + _(', in ') + title;
+          anchor = match[3];
+          if (anchor == '')
+            anchor = fullname;
+          else if (anchor == '-')
+            anchor = objnames[match[1]][1] + '-' + fullname;
+          result = [filenames[match[0]], fullname, '#'+anchor, descr];
+          switch (match[2]) {
+          case 1: objectResults.push(result); break;
+          case 0: importantResults.push(result); break;
+          case 2: unimportantResults.push(result); break;
+          }
+        }
+      }
+    }
+
+    // sort results descending
+    objectResults.sort(function(a, b) {
+      return (a[1] > b[1]) ? -1 : ((a[1] < b[1]) ? 1 : 0);
+    });
+
+    importantResults.sort(function(a, b) {
+      return (a[1] > b[1]) ? -1 : ((a[1] < b[1]) ? 1 : 0);
+    });
+
+    unimportantResults.sort(function(a, b) {
+      return (a[1] > b[1]) ? -1 : ((a[1] < b[1]) ? 1 : 0);
+    });
+
+    return [importantResults, objectResults, unimportantResults]
   }
 }
Index: pr_inversion/docs/sphinx/html/_static/sidebar.js
===================================================================
--- pr_inversion/docs/sphinx/html/_static/sidebar.js	(revision a7c772ea8096f970be31b02f50fc8daa9d572a54)
+++ pr_inversion/docs/sphinx/html/_static/sidebar.js	(revision 888499639fdcac9ce5f05f9de8a422019fba20a0)
@@ -29,4 +29,7 @@
   var sidebar = $('.sphinxsidebar');
   var sidebarwrapper = $('.sphinxsidebarwrapper');
+
+  // for some reason, the document has no sidebar; do not run into errors
+  if (!sidebar.length) return;
 
   // original margin-left of the bodywrapper and width of the sidebar
Index: pr_inversion/docs/sphinx/html/_static/underscore.js
===================================================================
--- pr_inversion/docs/sphinx/html/_static/underscore.js	(revision a7c772ea8096f970be31b02f50fc8daa9d572a54)
+++ pr_inversion/docs/sphinx/html/_static/underscore.js	(revision 888499639fdcac9ce5f05f9de8a422019fba20a0)
@@ -1,2 +1,9 @@
+// Underscore.js 0.5.5
+// (c) 2009 Jeremy Ashkenas, DocumentCloud Inc.
+// Underscore is freely distributable under the terms of the MIT license.
+// Portions of Underscore are inspired by or borrowed from Prototype.js,
+// Oliver Steele's Functional, and John Resig's Micro-Templating.
+// For all details and documentation:
+// http://documentcloud.github.com/underscore/
 (function(){var j=this,n=j._,i=function(a){this._wrapped=a},m=typeof StopIteration!=="undefined"?StopIteration:"__break__",b=j._=function(a){return new i(a)};if(typeof exports!=="undefined")exports._=b;var k=Array.prototype.slice,o=Array.prototype.unshift,p=Object.prototype.toString,q=Object.prototype.hasOwnProperty,r=Object.prototype.propertyIsEnumerable;b.VERSION="0.5.5";b.each=function(a,c,d){try{if(a.forEach)a.forEach(c,d);else if(b.isArray(a)||b.isArguments(a))for(var e=0,f=a.length;e<f;e++)c.call(d,
 a[e],e,a);else{var g=b.keys(a);f=g.length;for(e=0;e<f;e++)c.call(d,a[g[e]],g[e],a)}}catch(h){if(h!=m)throw h;}return a};b.map=function(a,c,d){if(a&&b.isFunction(a.map))return a.map(c,d);var e=[];b.each(a,function(f,g,h){e.push(c.call(d,f,g,h))});return e};b.reduce=function(a,c,d,e){if(a&&b.isFunction(a.reduce))return a.reduce(b.bind(d,e),c);b.each(a,function(f,g,h){c=d.call(e,c,f,g,h)});return c};b.reduceRight=function(a,c,d,e){if(a&&b.isFunction(a.reduceRight))return a.reduceRight(b.bind(d,e),c);
